#define STB_IMAGE_IMPLEMENTATION
#include "stb_image.cpp"
/*
public domain license, Kissinger 2 convert to bdf script
Piotr Grochowski, piotrunio-2004@wp.pl

The name of Kissinger 2 and the names of its contributors may be used to endorse
and/or promote products derived from this software. The contributor names
include "Piotr Grochowski".

All trademark and patent rights held by Type Design are waived, abandoned, 
surrendered, licensed and affected by this document.

This copyright notice and this permission notice do not have to appear in any
copies or derivative works.

Permission to use, copy, modify, and/or distribute this software for any purpose
with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND
FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF
THIS SOFTWARE.
*/
#include <string>
#include <sstream>
#include <iostream>
#include <fstream>
#include <vector>
int* imagef;
int* imageh;
#define COPYRIGHTH "public domain - contributors: Piotr Grochowski (piotrunio-2004@wp.pl)"
#define COPYRIGHTF COPYRIGHTH
std::string bdfh = "STARTFONT 2.1\nCOMMENT \"This is the halfwidth of the development of Kissinger 2, the successor of Kissinger and competitor of U***ont.\"\nFONT -Type Design-Kissinger 2-Regular-R-Normal--16-167-96-96-C-80-ISO10646-1\nSIZE 16 96 96\nFONTBOUNDINGBOX 8 16 0 -8\nSTARTPROPERTIES 33\nFOUNDRY \"Type Design\"\nFAMILY_NAME \"Kissinger 2\"\nWEIGHT_NAME \"Regular\"\nSLANT \"R\"\nSETWIDTH_NAME \"Normal\"\nADD_STYLE_NAME \"\"\nPIXEL_SIZE 16\nPOINT_SIZE 167\nRESOLUTION_X 96\nRESOLUTION_Y 96\nSPACING \"C\"\nAVERAGE_WIDTH 80\nCHARSET_REGISTRY \"ISO10646\"\nCHARSET_ENCODING \"1\"\nFONTNAME_REGISTRY \"\"\nFONT_NAME \"Kissinger2\"\nFACE_NAME \"Kissinger 2\"\nCOPYRIGHT \"" COPYRIGHTH "\"\nFONT_VERSION \"\"\nFONT_ASCENT 8\nFONT_DESCENT 8\nUNDERLINE_POSITION -7\nUNDERLINE_THICKNESS 1\nX_HEIGHT 8\nCAP_HEIGHT 10\nRAW_ASCENT 500\nRAW_DESCENT 500\nNORM_SPACE 8\nRELATIVE_WEIGHT 40\nRELATIVE_SETWIDTH 50\nFIGURE_WIDTH 8\nAVG_LOWERCASE_WIDTH 80\nAVG_UPPERCASE_WIDTH 80\nENDPROPERTIES\n";
std::string bdff = "STARTFONT 2.1\nCOMMENT \"This is the fullwidth of the development of Kissinger 2, the successor of Kissinger and competitor of U***ont.\"\nFONT -Type Design-Kissinger 2f-Regular-R-Normal--16-167-96-96-C-160-ISO10646-1\nSIZE 16 96 96\nFONTBOUNDINGBOX 8 16 0 -8\nSTARTPROPERTIES 33\nFOUNDRY \"Type Design\"\nFAMILY_NAME \"Kissinger 2f\"\nWEIGHT_NAME \"Regular\"\nSLANT \"R\"\nSETWIDTH_NAME \"Normal\"\nADD_STYLE_NAME \"\"\nPIXEL_SIZE 16\nPOINT_SIZE 167\nRESOLUTION_X 96\nRESOLUTION_Y 96\nSPACING \"C\"\nAVERAGE_WIDTH 160\nCHARSET_REGISTRY \"ISO10646\"\nCHARSET_ENCODING \"1\"\nFONTNAME_REGISTRY \"\"\nFONT_NAME \"Kissinger2f\"\nFACE_NAME \"Kissinger 2f\"\nCOPYRIGHT \"" COPYRIGHTF "\"\nFONT_VERSION \"\"\nFONT_ASCENT 8\nFONT_DESCENT 8\nUNDERLINE_POSITION -7\nUNDERLINE_THICKNESS 1\nX_HEIGHT 8\nCAP_HEIGHT 10\nRAW_ASCENT 500\nRAW_DESCENT 500\nNORM_SPACE 16\nRELATIVE_WEIGHT 40\nRELATIVE_SETWIDTH 50\nFIGURE_WIDTH 16\nAVG_LOWERCASE_WIDTH 160\nAVG_UPPERCASE_WIDTH 160\nENDPROPERTIES\n";
struct glyph{
 std::string name = "uni";
 int encoding;
 int swidth = 500;
 int dwidth = 8;
 int bbx[4] = {8,16,0,-8,};
 std::string bitmap = "";
};
std::vector<glyph> qqh;
std::vector<glyph> qqf;
		const char* hex = "0123456789ABCDEFGH";
		std::vector<int> iih = {0,1,2,3,7,8,};
		std::vector<int> iif = {0,1,2,3,4,5,6,7,14,15,16,17,};
		const int subplanes = 6;
std::fstream input;
std::fstream output;
int main(){
	imagef = (int*)malloc(2048*(2048*subplanes)*sizeof(int));
	imageh = (int*)malloc(1024*(2048*subplanes)*sizeof(int));
	{
		char f[] = "kissinger2test0.png";
		unsigned char* b;
		for(int i=0; i<iih.size(); i++){
			f[14]=hex[iih[i]];
  int width, height, n;
  b = stbi_load(f, &width, &height, &n, 4);
  for(int j=0; j<1024*2048*4; j++) ((char*)(imageh))[i*4*1024*2048+j]=b[j];
		}
	}
	{
		char f[] = "kissinger2ftest0.png";
		unsigned char* b;
		for(int i=0; i<iif.size(); i++){
			f[15]=hex[iif[i]];
  int width, height, n;
  b = stbi_load(f, &width, &height, &n, 4);
  for(int j=0; j<1024*2048*4; j++) ((char*)(imagef))[i*4*1024*2048+j]=b[j];
		}
	}
 for(int i=0; i<16384*subplanes; i++){
	int x = (i&0x7F)* 8+((i>>7)*16)*1024;
	int c = (i&0x7F)*16+((i>>7)*16)*2048;
	bool hashalfwidth = ((imageh[x]>>0)&0xFF)==((imageh[x]>>8)&0xFF);
	bool hasfullwidth = ((imagef[c]>>0)&0xFF)==((imagef[c]>>8)&0xFF);
  if(hashalfwidth){
   glyph q;
   q.encoding = (iih[i>>14]<<14)|(i&16383);
   if(q.encoding>>16) {if(q.encoding>>20)q.name.push_back(hex[(q.encoding>>20)&0xF]);
   q.name.push_back(hex[(q.encoding>>16)&0xF]); }
   q.name.push_back(hex[(q.encoding>>12)&0xF]);
   q.name.push_back(hex[(q.encoding>> 8)&0xF]);
   q.name.push_back(hex[(q.encoding>> 4)&0xF]);
   q.name.push_back(hex[(q.encoding>> 0)&0xF]);
   if(i==0) {q.encoding=-1; q.name=".notdef";}
   for(int j=0; j<16; j++){
    int w = 0;
    for(int a=0; a<4; a++){
     w<<=1; w|=(imageh[x+a+j*1024]==0xFF000000);
    }
    q.bitmap.push_back(hex[w]);
    w=0;
    for(int a=4; a<8; a++){
     w<<=1; w|=(imageh[x+a+j*1024]==0xFF000000);
    }
    q.bitmap.push_back(hex[w]);
    q.bitmap.push_back('\n');
   }
   qqh.push_back(q);
  }
  if(hasfullwidth){
   glyph q;
   q.swidth = 1000;
   q.dwidth = 16;
   q.bbx[0] = 16;
   q.encoding = (iih[i>>14]<<14)|(i&16383);
   if(q.encoding>>16) {if(q.encoding>>20)q.name.push_back(hex[(q.encoding>>20)&0xF]);
   q.name.push_back(hex[(q.encoding>>16)&0xF]); }
   q.name.push_back(hex[(q.encoding>>12)&0xF]);
   q.name.push_back(hex[(q.encoding>> 8)&0xF]);
   q.name.push_back(hex[(q.encoding>> 4)&0xF]);
   q.name.push_back(hex[(q.encoding>> 0)&0xF]);
   if(i==0) {q.encoding=-1; q.name=".notdef";}
   for(int j=0; j<16; j++){
    int w = 0;
    for(int a=0; a<4; a++){
     w<<=1; w|=(imagef[c+a+j*2048]==0xFF000000);
    }
    q.bitmap.push_back(hex[w]);
    w=0;
    for(int a=4; a<8; a++){
     w<<=1; w|=(imagef[c+a+j*2048]==0xFF000000);
    }
    q.bitmap.push_back(hex[w]);
    w=0;
    for(int a=8; a<12; a++){
     w<<=1; w|=(imagef[c+a+j*2048]==0xFF000000);
    }
    q.bitmap.push_back(hex[w]);
    w=0;
    for(int a=12; a<16; a++){
     w<<=1; w|=(imagef[c+a+j*2048]==0xFF000000);
    }
    q.bitmap.push_back(hex[w]);
    q.bitmap.push_back('\n');
   }
   qqf.push_back(q);
  }
 }
 {
 std::stringstream s;
 s << "CHARS " << qqh.size() << '\n';
 for(int i=0; i<qqh.size(); i++){
  s << "STARTCHAR " << qqh[i].name << '\n';
  s << "ENCODING " << qqh[i].encoding << '\n';
  s << "SWIDTH " << qqh[i].swidth << " 0\n";
  s << "DWIDTH " << qqh[i].dwidth << " 0\n";
  s << "BBX " << qqh[i].bbx[0] << ' ' << qqh[i].bbx[1] << ' ' << qqh[i].bbx[2] << ' ' << qqh[i].bbx[3] << '\n';
  s << "BITMAP\n" << qqh[i].bitmap;
  s << "ENDCHAR\n";
 }
 s << "ENDFONT\n";
 bdfh.append(s.str());
 }
 {
 std::stringstream s;
 s << "CHARS " << qqf.size() << '\n';
 for(int i=0; i<qqf.size(); i++){
  s << "STARTCHAR " << qqf[i].name << '\n';
  s << "ENCODING " << qqf[i].encoding << '\n';
  s << "SWIDTH " << qqf[i].swidth << " 0\n";
  s << "DWIDTH " << qqf[i].dwidth << " 0\n";
  s << "BBX " << qqf[i].bbx[0] << ' ' << qqf[i].bbx[1] << ' ' << qqf[i].bbx[2] << ' ' << qqf[i].bbx[3] << '\n';
  s << "BITMAP\n" << qqf[i].bitmap;
  s << "ENDCHAR\n";
 }
 s << "ENDFONT\n";
 bdff.append(s.str());
 }
 output.open("kissinger2test.bdf", std::ios::out|std::ios::binary);
 output.write((char*)&bdfh[0], bdfh.size());
 output.close();
 output.open("kissinger2ftest.bdf", std::ios::out|std::ios::binary);
 output.write((char*)&bdff[0], bdff.size());
 output.close();
 std::cout << "DONE";
}