#define STB_IMAGE_IMPLEMENTATION
#include "stb_image.cpp"
#define STB_IMAGE_WRITE_IMPLEMENTATION
#include "stb_image_write.cpp"
/*
public domain license, Kissinger 2 highlight red glyph in the other width script
Piotr Grochowski, piotrunio-2004@wp.pl

The name of Kissinger 2 and the names of its contributors may be used to endorse
and/or promote products derived from this software. The contributor names
include "Piotr Grochowski".

All trademark and patent rights held by Type Design are waived, abandoned, 
surrendered, licensed and affected by this document.

This copyright notice and this permission notice do not have to appear in any
copies or derivative works.

Permission to use, copy, modify, and/or distribute this software for any purpose
with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND
FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF
THIS SOFTWARE.
*/

#include <iostream>
#include <fstream>
#include <vector>
		const char* hex = "0123456789ABCDEFGH";
		std::vector<int> iih = {0,1,2,3,7,8,};
		std::vector<int> iif = {0,1,2,3,4,5,6,7,14,15,16,17,};
		const int subplanes = 6;
int* imagef;
int* imageh;
int main(){
	imagef = (int*)malloc(2048*(2048*subplanes)*sizeof(int));
	imageh = (int*)malloc(1024*(2048*subplanes)*sizeof(int));
	{
		char f[] = "kissinger2test0.png";
		unsigned char* b;
		for(int i=0; i<iih.size(); i++){
			f[14]=hex[iih[i]];
  int width, height, n;
  b = stbi_load(f, &width, &height, &n, 4);
  for(int j=0; j<1024*2048*4; j++) ((char*)(imageh))[i*4*1024*2048+j]=b[j];
		}
	}
	{
		char f[] = "kissinger2ftest0.png";
		unsigned char* b;
		for(int i=0; i<iif.size(); i++){
			f[15]=hex[iif[i]];
  int width, height, n;
  b = stbi_load(f, &width, &height, &n, 4);
  for(int j=0; j<1024*2048*4; j++) ((char*)(imagef))[i*4*1024*2048+j]=b[j];
		}
	}
	for(int z=0; z<16384*subplanes; z++){
		int x = (z&0x7F)* 8+((z>>7)*16)*1024;
		int c = (z&0x7F)*16+((z>>7)*16)*2048;
		bool hashalfwidth = ((imageh[x]>>0)&0xFF)==((imageh[x]>>8)&0xFF);
		bool hasfullwidth = ((imagef[c]>>0)&0xFF)==((imagef[c]>>8)&0xFF);
		if(hasfullwidth&&!hashalfwidth){
		for(int i=0; i<16; i++) for(int j=0; j<8; j++) {
			imageh[(i+16*(z>>7))*1024+((z&127)*8+j)] = (((z>>0)&1)^((z>>7)&1))?0xFF9999CC:0xFFCCCCFF;
		}	
		}
		if(hashalfwidth&&!hasfullwidth){
		for(int i=0; i<16; i++) for(int j=0; j<16; j++) {
			imagef[(i+16*(z>>7))*2048+((z&127)*16+j)] = (((z>>0)&1)^((z>>7)&1))?0xFF9999CC:0xFFCCCCFF;
		}	
		}
		continue;
	}
	char a[] = "kissinger2ftest0.png";
	for(int i=0; i<iif.size(); i++){
		a[15]=hex[iif[i]];
		stbi_write_png(a,2048,1024,4,(char*)(imagef+(2048*1024*i)),2048*4);
	}
	char b[] = "kissinger2test0.png";
	for(int i=0; i<iih.size(); i++){
		b[14]=hex[iih[i]];
		stbi_write_png(b,1024,2048,4,(char*)(imageh+(1024*2048*i)),1024*4);
	}
	std::cout << "DONE";
	free(imagef); free(imageh);
	return 0;
}